#!/bin/bash

export LANG=C 

##1)  ressauts  Froude in  1.2 1.5 2.0 
##2)  une bosse qui se casse ##############################
##3)  rupture de barrage ###############
##4)  cas equilibre du lac   ###############
##5)  bosse supercritique  Fr = 1.7 #########
##6)  bosse trans critique  Fr = 0.59 #########
##7)  bosse subcritique  Fr = 0.5 #########
##8)  tas Huppert #########
##9)  Nusselt   


rm *.ps
echo " go"





##1) ressauts   v ########################################
for Froude in  1.2 1.5 2.0 
do 
echo $Froude

cat<<FdF>donneb.in
cas=2
dt=0.015
tmax=10
dx=0.025
nx=1000
Fr=$Froude
Cf=0
icl=0
h0=1
xbosse=0
lbosse=0
abosse=0
alpha=0
FdF

rm solxhQZ.OUT
./sv donneb.in | gnuplot
awk '{ a[NR]=$0 } END { for(i=NR; i; --i) print a[i] } '  solxhQZ.OUT  > a$Froude.txt
 
done

cat<<EOF>a.gnu
set title "ressaut fixe, Fr=1.2 1.5 et 2.0 "
set xlabel "x"
set ylabel "h(x,t)"
set key bottom
p[-12.5:12.5]\
'a2.0.txt'  every :::::0 t'Fr=3.0'  w l,\
'a1.5.txt'  every :::::0 t'Fr=1.5'  w l,\
'a1.2.txt'  every :::::0 t'Fr=1.2'  w l,\
0 not
set term post 
set output 'F_ressaut.ps'
replot
EOF
gnuplot a.gnu
rm a.gnu 

rm a*.txt
## fin ressauts ########################################


##2) une bosse qui se casse ##############################

cat<<FdF>donneb.in
cas=0
dt=0.01
tmax=32
dx=0.025
nx=2000
Fr=0
icl=0
h0=1
xbosse=0
lbosse=0
abosse=0.1
alpha=0
FdF

rm solxhQZ.OUT
./sv donneb.in | gnuplot

cat<<EOF>a.gnu
set title " bosse qui se déplace "
set xlabel "x"
set ylabel "t"
set title "h(x,t)"
p[:][1:]'solxhQZ.OUT' u (\$1):(\$2+\$4/10)  every :2 w l not 
set term post 
set output 'Bossz.ps'
replot
EOF
gnuplot a.gnu
rm a.gnu 

## http://www.physics.iitm.ac.in/~sanoop/linux_files/gnuplot-every.html
## fin d'une bosse qui se casse ########################

##2) une bosse qui se casse sur la plage##############################

cat<<FdF>donneb.in
cas=0
dt=0.01
tmax=50
dx=0.025
nx=1000
Fr=0
icl=0
h0=1
xbosse=5
lbosse=0
abosse=0.2
alpha=0.2
FdF

rm solxhQZ.OUT
./sv donneb.in | gnuplot

cat<<EOF>a.gnu
set title " bosse qui se déplace "
set xlabel "x"
set ylabel "t"
set title "h(x,t)"
p[-15:15][1:]'solxhQZ.OUT' u (\$1):(\$2+\$4/10)  every :2 w l not 
set term post 
set output 'Bosszplage.ps'
replot
EOF
gnuplot a.gnu
rm a.gnu 


## fin d'une bosse qui se casse sur la palge########################

##3)########## DEBUT rupture de barrage ###############
cat<<FdF>donneb.in
cas=1
dt=0.01
tmax=20
dx=0.05
nx=1000
Fr=0
Cf=0
icl=0
h0=1
xbosse=0
lbosse=5
abosse=0
alpha=0
FdF

rm solxhQZ.OUT
./sv donneb.in | gnuplot

cp solxhQZ.OUT sol.OUT

cat<<EOF>a.gnu
set title "Dam "
set xlabel "x"
set ylabel "h(x,t)"
p[-25:25]'sol.OUT' u 1:2 every :4 t'h(x,t)' w l
set term post 
set output 'DB.ps'
replot
EOF
gnuplot a.gnu
rm a.gnu 


cat<<EOF>a.gnu
set title "Dam "
set xlabel "x"
set ylabel "t"
set zlabel "h(x,t)"
set hidden3d
sp[-25:25][0:20][0:1]'sol.OUT' u 1:4:2 every 10  w l linec 3 not
set term post 
set output 'DB2.ps'
replot
EOF
gnuplot a.gnu
rm a.gnu 

################ FIN rupture de barrage ###############



##4)############ cas equilibre du lac   ###############

cat<<FdF>donneb.in
cas=5
dt=0.05
tmax=120
dx=0.1
nx=500
Fr=0
Cf=0
icl=0
h0=1
xbosse=0
lbosse=5
abosse=0.9
alpha=0
FdF
rm solxhQZ.OUT
./sv donneb.in | gnuplot


cp solxhQZ.OUT sol.OUT

cat<<EOF>a.gnu
set title "Equilibre du lac "
set xlabel "x"
set ylabel "h(x,t)"
p[:]'sol.OUT' u 1:2 every :4 t'h(x,t)' w l
set term post 
set output 'equi.ps'
replot
EOF
gnuplot a.gnu
rm a.gnu 

################ FIN equilibre du lac  ###############





##5)#############  bosse supercritique  Fr = 1.7 #########
cat<<FdF>donneb.in
cas=4
dt=0.05
tmax=100
dx=0.1
nx=500
Fr=1.7
Cf=0
icl=0
h0=1
xbosse=0
lbosse=5
abosse=0.125
alpha=0
FdF


rm solxhQZ.OUT
./sv donneb.in | gnuplot
mv sol.OUT sol1p7.OUT

cat<<EOF>a.gnu
set key bottom
set xlabel "x"
set ylabel "Z, h, u"
F=1.7
p[-25:25]'sol1p7.OUT' u 1:(\$3/\$2) t'u calc' w l,''u 1:(F*(1+\$4/(1-F*F))) t 'F (1+Z(x)/(1-F*F))'   w l,\
'' u 1:(\$2) t'h' w l,''u 1:(1+\$4/(F*F-1)) t '(1+Z(x)/(F*F-1))' w l,\
'' u 1:4 t 'Z(x)' w l linec -1
set term post 
set output 'ZF1p7.ps'
replot
EOF
gnuplot a.gnu
rm a.gnu 


##6)#############  bosse trans critique  Fr = 0.59 #########

cat<<FdF>donneb.in
cas=4
dt=0.05
tmax=800
dx=0.1
nx=500
Fr=.59
Cf=0
icl=0
h0=1
xbosse=0
lbosse=5
abosse=0.125
alpha=0
FdF


rm solxhQZ.OUT
./sv donneb.in | gnuplot
mv sol.OUT sol0p59.OUT

cat<<EOF>a.gnu
set key bottom
set xlabel "x"
set ylabel "Z, h, u"
F=0.59
p[-25:25]'sol0p59.OUT' u 1:(\$3/\$2) t'u calc' w l,''u 1:(F*(1+\$4/(1-F*F))) t 'F (1+Z(x)/(1-F*F))'   w l,\
'' u 1:(\$2) t'h' w l,''u 1:(1+\$4/(F*F-1)) t '(1+Z(x)/(F*F-1))' w l,\
'' u 1:4 t 'Z(x)' w l linec -1
set term post 
set output 'ZF0p59.ps'
replot
EOF
gnuplot a.gnu
rm a.gnu 



##7)#############  bosse sub critique  Fr = 0.5 #########


Froude=.5

cat<<FdF>donneb.in
cas=4
dt=0.05
tmax=120
dx=0.1
nx=500
Fr=$Froude
Cf=0
icl=0
h0=1
xbosse=0
lbosse=5
abosse=0.125
alpha=0
FdF



rm solxhQZ.OUT
./sv donneb.in | gnuplot
mv sol.OUT sol0p5.OUT

cat<<EOF>a.gnu
set key bottom
set xlabel "x"
set ylabel "Z, h, u"
F=0.5
p[-25:25]'sol0p5.OUT' u 1:(\$3/\$2) t'u calc' w l,''u 1:(F*(1+\$4/(1-F*F))) t 'F (1+Z(x)/(1-F*F))'   w l,\
'' u 1:(\$2) t'h' w l,''u 1:(1+\$4/(F*F-1)) t '(1+Z(x)/(F*F-1))' w l,\
'' u 1:4 t 'Z(x)' w l linec -1
set term post 
set output 'ZF0p5.ps'
replot
EOF
gnuplot a.gnu
rm a.gnu 

###### FIN #########  bosse sub critique  Fr = 0.5 #########



##8)#############  Tas Huppert #########

cat<<FdF>donneb.in
cas=6
dt=0.0025
tmax=500
dx=0.025
nx=1200
Fr=0
Cf=.125
icl=0
h0=1
xbosse=0
lbosse=0
abosse=0.
alpha=0.
FdF




./sv donneb.in | gnuplot

cat<<EOF>a.gnu
set key bottom
set xlabel "t"
set ylabel "h0, xf"
set log x
set log y
p[1:]'solxhFront.OUT' u 1:3t'xf' w l,'' w l,2.45*x**.2,.53*x**(-.2)
set term post 
set output 'xfh0.ps'
replot
reset
set term x11
set output
p[0:3][0:]'solxhQZ.OUT' u (\$1/(\$4**.2)):(\$2*(\$4**.2)) w l,((3./10)*(2-x*x))**(1./3)
set output 'tas_hup.ps'
replot
EOF
gnuplot a.gnu
rm a.gnu 


###### FIN #########  bosse  




 







